Option Strict Off
Option Explicit On

Module RulawiNT

	Dim FLG, QE, QI, QM, FRI As Short
	Dim CAR(255), KODAR(255), UTF() As Short
	Dim IMO, COT, IMI, MASK, FIL(255) As String
	Dim VYVOD As Boolean

	Public Sub Main()
		Console.Title = "RulawiNT"
		COT = Command() : If Len(COT) < 3 Then COT = ""
		If COT = "" Then HELPLIST()
		COMLINE()
		If IMI = "" Then HELPLIST()
		VYBOR()
		KONEC()
	End Sub

	Private Sub HELPLIST()
		Console.ForegroundColor = ConsoleColor.Gray
		Console.BackgroundColor = ConsoleColor.Black
		Console.OutputEncoding = System.Text.Encoding.Default
		Console.Clear()
		Console.WriteLine(" RUssian/LAtin/WIndows converter of symbols, version 10 (size 23040) ")
		Console.WriteLine("    (C) E.H.Hauser, Baku, 29/09/22, 10:00:00, `www.erichware.com` ")
		Console.WriteLine(" usage: >RulawiNT.exe [!]option source [target] ")
		Console.WriteLine(" Warning! First symbol is `!` for NO console output! ")
		Console.WriteLine("     L or R - for  russian -> latin    or    latin -> russian  transformation ")
		Console.WriteLine("     W or D - for      dos -> windows  or  windows -> dos      transformation ")
		Console.WriteLine("     K or A - for      dos -> koi8     or     koi8 -> dos      transformation ")
		Console.WriteLine("     I or N - for  windows -> koi8     or     koi8 -> windows  transformation ")
		Console.WriteLine("     T or S - for    utf-8 -> windows  or  unicode -> dos      transformation ")
		Console.WriteLine("     F or U - for  windows -> utf-8    or      dos -> unicode  transformation ")
		Console.WriteLine("     B or C - for  windows -> utf-8    or      dos -> unicode  transformation ")
		Console.WriteLine(" Options F and U add the signature to the file, and options B and C do not add.")
		Console.WriteLine(" After russian-latin transformation of 33 letters of Russian alphabet such ")
		Console.WriteLine(" symbols are put in the conformity: ")
		Console.WriteLine("   abvgdeejziiklmnoprstufxchww`y`eqa ")
		Console.WriteLine(" After latin-russian transformation of 26 letters of Latin alphabet such ")
		Console.WriteLine(" symbols are put in the conformity: ")
        Console.WriteLine("    ")
        Console.WriteLine(" If in a `source` there are symbols `*` or `?`, the operation is made with ")
		Console.WriteLine(" all files, satisfying specified to this mask of search. ")
		Console.WriteLine(" Examples: ")
		Console.WriteLine(" C:\UTIL\>RulawiNT w namedos.txt [namewin.win] ")
		Console.WriteLine(" C:\UTIL\>RulawiNT w *.txt [win] ")
		Console.WriteLine(" C:\UTIL\>RulawiNT !w namedos.* [namewin] ")
		VYVOD = True : KONEC()
	End Sub

	Private Sub COMLINE()
		Dim IMA, Q, EXT As String
		Dim QQ As Short
		Q = UCase(Left(COT, 1)) : VYVOD = True
		If Q = "!" Then VYVOD = False : COT = Mid(COT, 2) : Q = UCase(Left(COT, 1))
		IMI = Mid(COT, 3)
		Select Case Q
			Case "W" : FLG = 1 : Case "D" : FLG = 2
			Case "K" : FLG = 3 : Case "A" : FLG = 4
			Case "I" : FLG = 5 : Case "N" : FLG = 6
			Case "R" : FLG = 7 : Case "L" : FLG = 8
			Case "S" : FLG = 9 : Case "U" : FLG = 10
			Case "F" : FLG = 11 : Case "T" : FLG = 12
			Case "B" : FLG = 13 : Case "C" : FLG = 14
			Case Else : IMI = "" : Exit Sub
		End Select
		QQ = InStr(1, IMI, " ") : If QQ = 0 Then QQ = Len(IMI) + 1
		If QQ = 1 Then IMI = "" : Exit Sub
		MASK = Mid(IMI, QQ + 1) : IMI = Left(IMI, QQ - 1)
		If MASK <> "" Then
			QQ = InStr(1, IMI, ".") : If QQ = 0 Then QQ = Len(IMI) + 1
			IMA = Left(IMI, QQ - 1) : EXT = Mid(IMI, QQ)
			QI = InStr(1, IMA, "?") + InStr(1, IMA, "*")
			QE = InStr(1, EXT, "?") + InStr(1, EXT, "*")
			QM = InStr(1, MASK, "?") + InStr(1, MASK, "*")
			If QI > 0 And QE > 0 Or QM > 0 Then IMI = ""
		End If
	End Sub

	Private Sub CONVERT()
		Dim I, NDRO, LF, NCEL, II, DLI As Integer
		Dim F As Short
		Dim T, S, P, D As String
		Dim KOD(255) As String
		If VYVOD Then Console.WriteLine(IMI)
		FileOpen(1, IMI, OpenMode.Binary) : LF = LOF(1)
		FileOpen(2, IMO, OpenMode.Output) : FileClose(2) : FileOpen(2, IMO, OpenMode.Binary)
		NCEL = Int(LF / 1024) : NDRO = LF - NCEL * 1024
		If FLG = 10 Or FLG = 14 Then 'DOSUNI
			If FLG = 10 Then F = -257 : FilePut(2, F)
			For I = 32 To 127 : KODAR(I) = I : Next I
			For I = 128 To 175 : KODAR(I) = I + 912 : Next I
			For I = 224 To 239 : KODAR(I) = I + 864 : Next I
			T = My.Resources.str107
			For I = 0 To 31 : KODAR(I) = Val(Mid(T, I * 5 + 1, 5)) : Next I
			T = My.Resources.str108
			For I = 0 To 47 : KODAR(I + 176) = Val(Mid(T, I * 4 + 1, 4)) : Next I
			For I = 0 To 15 : KODAR(I + 240) = Val(Mid(T, (48 + I) * 4 + 1, 4)) : Next I
		ElseIf FLG = 9 Then	 'UNIDOS
			T = My.Resources.str106
			For I = 0 To 147 : KODAR(I) = Asc(Mid(T, I + 1, 1)) : Next I
			T = My.Resources.str108
			For I = 0 To 15 : KODAR(I + 148) = Val(Mid(T, (48 + I) * 4 + 1, 4)) : Next I
			T = My.Resources.str107
			For I = 0 To 31 : KODAR(I + 164) = Val(Mid(T, I * 5 + 1, 5)) : Next I
		ElseIf FLG = 11 Or FLG = 13 Then  'WINUTF
			For I = 0 To 191 : KOD(I) = Chr(I) : Next I
			T = My.Resources.str109
			For I = 192 To 255 : KOD(I) = Mid(T, (I - 192) * 2 + 1, 2) : Next I
			S = InputString(1, LF) : T = StrDup(LF * 2, Chr(0)) : II = 1
			If FLG = 11 Then P = Chr(239) & Chr(187) & Chr(191) : FilePut(2, P)
			For I = 1 To LF
				F = Asc(Mid(S, I, 1)) : P = KOD(F) : F = Len(P) : Mid(T, II, F) = P : II = II + F
			Next I
			T = Left(T, II - 1)
			FilePut(2, T)
		ElseIf FLG = 12 Then  'UTFWIN
			For I = 0 To 191 : KOD(I) = Chr(127) : Next I
			T = My.Resources.str109
			For I = 192 To 255 : KOD(I) = Mid(T, (I - 192) * 2 + 1, 2) : Next I
			T = StrDup(LF, Chr(0)) : S = InputString(1, LF) : II = 1 : F = 1
			If Left(S, 3) = Chr(239) & Chr(187) & Chr(191) Then F = 4
			For I = F To LF
				P = Mid(S, I, 2) : D = Left(P, 1)
				If Asc(D) > 127 Then
					For F = 192 To 255
						If P = KOD(F) Then Exit For
					Next F
					I = I + 1 : If F < 256 Then D = Chr(F) Else D = Chr(127)
				End If
				Mid(T, II, 1) = D : II = II + 1
			Next I
			T = Left(T, II - 1)
			FilePut(2, T)
		End If
		If FLG < 11 Or FLG = 14 Then
			For II = 0 To NCEL
				If FLG = 9 Then
					DLI = 512
					If II = NCEL Then
						DLI = NDRO / 2 : If DLI = 0 Then Exit For
					End If
					ReDim UTF(DLI - 1)
					FileGet(1, UTF)
					UNITODOS(DLI, P)
					FilePut(2, P)
				Else
					S = InputString(1, 1024)
					If FLG = 10 Or FLG = 14 Then
						If S <> "" Then
							ReDim UTF(Len(S) - 1)
							DOSTOUNI(S)
							FilePut(2, UTF)
						End If
					Else
						PREOKODI(S, P)
						FilePut(2, P)
					End If
				End If
				S = Str(CShort((II + 1) * 100 / (NCEL + 1))) & "%"
				If VYVOD Then Console.Write(S)
			Next II
		End If
		FileClose(1, 2)
		If VYVOD Then Console.WriteLine("")
	End Sub

	Private Sub ARRAYSET()
		Dim I As Short
		Dim T As String
		For I = 0 To 255 : CAR(I) = I : Next I
		Select Case FLG
			Case 1 'DOSWIN
				For I = 128 To 175 : CAR(I) = I + 64 : Next I
				For I = 176 To 223 : CAR(I) = I - 48 : Next I
				For I = 224 To 239 : CAR(I) = I + 16 : Next I
				For I = 240 To 255 : CAR(I) = I - 64 : Next I
			Case 2 'WINDOS
				For I = 128 To 175 : CAR(I) = I + 48 : Next I
				For I = 176 To 191 : CAR(I) = I + 64 : Next I
				For I = 192 To 239 : CAR(I) = I - 64 : Next I
				For I = 240 To 255 : CAR(I) = I - 16 : Next I
			Case 3 : T = My.Resources.str103
				For I = 128 To 175 : CAR(I) = Val(Mid(T, (I - 128) * 3 + 1, 3)) : Next I
				For I = 176 To 191 : CAR(I) = I : Next I
				For I = 192 To 223 : CAR(I) = I - 64 : Next I
				For I = 224 To 239 : CAR(I) = Val(Mid(T, (I - 176) * 3 + 1, 3)) : Next I
				For I = 240 To 255 : CAR(I) = I - 80 : Next I
			Case 4 : T = My.Resources.str101
				For I = 128 To 159 : CAR(I) = I + 64 : Next I
				For I = 160 To 175 : CAR(I) = I + 80 : Next I
				For I = 176 To 191 : CAR(I) = I : Next I
				For I = 192 To 255 : CAR(I) = Val(Mid(T, (I - 192) * 3 + 1, 3)) : Next I
			Case 5 : T = My.Resources.str103
				For I = 128 To 143 : CAR(I) = I + 48 : Next I
				For I = 144 To 191 : CAR(I) = I - 16 : Next I
				For I = 192 To 255 : CAR(I) = Val(Mid(T, (I - 192) * 3 + 1, 3)) : Next I
			Case 6 : T = My.Resources.str102
				For I = 128 To 175 : CAR(I) = I + 16 : Next I
				For I = 176 To 191 : CAR(I) = I - 48 : Next I
				For I = 192 To 255 : CAR(I) = Val(Mid(T, (I - 192) * 3 + 1, 3)) : Next I
			Case 7 : T = My.Resources.str104
				For I = 64 To 127 : CAR(I) = Val(Mid(T, (I - 64) * 3 + 1, 3)) : Next I
			Case 8 : T = My.Resources.str105
				For I = 128 To 255 : CAR(I) = Val(Mid(T, (I - 128) * 3 + 1, 3)) : Next I
			Case Else
		End Select
	End Sub

	Private Sub DOSTOUNI(ByRef S As String)
		Dim I As Short
		For I = 1 To Len(S)
			UTF(I - 1) = KODAR(Asc(Mid(S, I, 1)))
		Next I
	End Sub

	Private Sub KONEC()
		If VYVOD Then
			Console.ForegroundColor = ConsoleColor.Red
			Console.BackgroundColor = ConsoleColor.Yellow
			Console.Write("Press <Enter> to exit...")
			Console.ForegroundColor = ConsoleColor.Gray
			Console.BackgroundColor = ConsoleColor.Black
			Console.Read()
		End If
		End
	End Sub

	Private Sub PREOKODI(ByRef S As String, ByRef P As String)
		Dim I As Short
		P = Space(Len(S))
		For I = 1 To Len(S)
			Mid(P, I, 1) = Chr(CAR(Asc(Mid(S, I, 1))))
		Next I
	End Sub

	Private Sub UNITODOS(ByRef DLIN As Integer, ByRef P As String)
		Dim UKOD, I, J, DKOD As Short
		P = ""
		For I = 0 To DLIN - 1
			UKOD = UTF(I)
			Select Case UKOD
				Case Is < 0 : DKOD = -1
				Case 0 To 127 : DKOD = UKOD
				Case 1040 To 1087 : DKOD = UKOD - 912
				Case 1088 To 1103 : DKOD = UKOD - 864
				Case 9472 To 9619 : DKOD = KODAR(UKOD - 9472)
				Case Else
					For J = 0 To 47
						If UKOD = KODAR(148 + J) Then Exit For
					Next J
					If J < 16 Then
						DKOD = 240 + J
					ElseIf J < 48 Then
						DKOD = J - 16
					Else
						DKOD = 127
					End If
			End Select
			If DKOD >= 0 And DKOD < 256 Then P = P & Chr(DKOD)
		Next I
	End Sub

	Private Sub VYBOR()
		Dim IMA, S, EXT As String
		Dim II, QQ As Short
		FRI = 0
		S = Dir(IMI)
		While S <> "" And FRI < 256
			FRI = FRI + 1 : FIL(FRI) = S
			S = Dir()
		End While
		ARRAYSET()
		If VYVOD Then Console.WriteLine("  RUssian/LAtin/WIndows converter of symbols, version 10 ")
		If VYVOD Then Console.WriteLine(" (C) E.H.Hauser, Baku, 29/09/22, `https://erichware.com` ")
		For II = 1 To FRI
			IMI = FIL(II)
			QQ = InStr(1, IMI, ".") : If QQ = 0 Then QQ = Len(IMI) + 1
			IMA = Left(IMI, QQ - 1) : EXT = Mid(IMI, QQ)
			If MASK <> "" Then
				If QI > 0 Then
					IMO = IMA & "." & MASK
				ElseIf QE > 0 Then
					IMO = MASK & EXT
				Else
					IMO = MASK
				End If
			Else
				IMO = "rulawi32.tmp"
			End If
			CONVERT()
			If MASK = "" Then Kill(IMI) : Rename(IMO, IMI)
		Next II
	End Sub

End Module
